lparameters tcTable
local lnCurrSelect, ;
	llUsed, ;
	lnCurrReprocess, ;
	luKey, ;
	lcKey, ;
	lcField

* Save the current work area, open the NEXTID table
* (if necessary), and find the desired table. If it
* doesn't exist, create a record for it.

lnCurrSelect = select()
llUsed       = used('NEXTID')
if llUsed
	select NEXTID
	set order to TABLE
else
	select 0
	use NEXTID order TABLE again shared
endif llUsed
seek upper(tcTable)
if not found()
	insert into NEXTID values (tcTable, 0)
endif not found()

* Increment the next available ID.

lnCurrReprocess = set('REPROCESS')
set reprocess to 10 seconds
if rlock()
	replace ID with ID + 1
	luKey = ID
	unlock
endif rlock()

* Set the data type of the return value to match the data type of the
* primary key for the table.

lcKey = dbgetprop(tcTable, 'Table', 'PrimaryKey')
if not empty(lcKey)
	lcField = key(tagno(lcKey, tcTable, tcTable), tcTable)
	if type(tcTable + '.' + lcField) = 'C'
		luKey = str(luKey, fsize(lcField, tcTable))
	endif type(tcTable + '.' + lcField) = 'C'
endif not empty(lcKey)

* Cleanup and return.

set reprocess to lnCurrReprocess
if not llUsed
	use
endif not llUsed
select (lnCurrSelect)
return luKey
